/*
 * 
 * The Seasar Software License, Version 1.1
 *
 * Copyright (c) 2003-2004 The Seasar Project. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or 
 * without modification, are permitted provided that the following 
 * conditions are met:
 *
 * 1. Redistributions of source code must retain the above 
 *    copyright notice, this list of conditions and the following 
 *    disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above 
 *    copyright notice, this list of conditions and the following 
 *    disclaimer in the documentation and/or other materials provided 
 *    with the distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgement:  
 *    "This product includes software developed by the 
 *    Seasar Project (http://www.seasar.org/)."
 *    Alternately, this acknowledgement may appear in the software
 *    itself, if and wherever such third-party acknowledgements 
 *    normally appear.
 *
 * 4. Neither the name "The Seasar Project" nor the names of its
 *    contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission of 
 *    the Seasar Project.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE SEASAR PROJECT 
 * OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL,SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING 
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.seasar.util.configuration.ognl;

import java.util.Map;

import ognl.ObjectPropertyAccessor;
import ognl.OgnlRuntime;

import org.apache.commons.configuration.Configuration;
import org.seasar.framework.beans.PropertyNotFoundRuntimeException;

/**
 * Commons ConfigurationOGNLň߂̃vpeBANZbTłB <br>
 * 
 * @author Koichi Kobayashi
 */
public class ConfigurationPropertyAccessor extends ObjectPropertyAccessor {
    static {
        OgnlRuntime.setPropertyAccessor(Configuration.class, new ConfigurationPropertyAccessor());
    }

    /**
     * vpeB <code>name</code> L[ƂđΉtꂽlԂ܂B
     * 
     * @param context
     *            ReLXg
     * @param target
     *            ^[Qbg
     * @param name
     *            vpeB
     * @throws PropertyNotFoundRuntimeException
     *             w肳ꂽvpeBɒl}bsOĂȂꍇɃX[܂
     */
    public Object getProperty(final Map context, final Object target, final Object name) {
        final Configuration config = (Configuration) target;
        final String key = name.toString();
        final Object value = config.getProperty(key);
        if (value == null) {
            throw new PropertyNotFoundRuntimeException(target.getClass(), key);
        }
        return value;
    }
}